.code

;VOID CreateTrigTables()
CreateTrigTables PROC
 mov ebx,0
 mov ecx,360
 mov fscratch4,0
 CTT_@loop:
  fild dword ptr [fscratch4]		;\
  fld qword ptr [deg2rad]		; \
  fmul					; convert degrees -> radians
  fstp qword ptr [fscratch8]		;/
  fld qword ptr [fscratch8]
  fcos
  fstp qword ptr [cosine_table + ebx]
  fld qword ptr [fscratch8]
  fsin
  fstp qword ptr [sine_table + ebx]
  add ebx,8
  inc fscratch4
  dec ecx
 jnz CTT_@loop
 ret
CreateTrigTables ENDP



vAdd PROC vtx1:LPVOID,vtx2:LPVOID,vtx_res:LPVOID
 mov esi,vtx1
 mov edx,vtx2
 mov edi,vtx_res
 fld qword ptr [esi]
 fadd qword ptr [edx]
 fstp qword ptr [edi]
 fld qword ptr [esi + 8]
 fadd qword ptr [edx + 8]
 fstp qword ptr [edi + 8]
 fld qword ptr [esi + 16]
 fadd qword ptr [edx + 16]
 fstp qword ptr [edi + 16]
 ret
vAdd ENDP



vSubtract PROC vtx1:LPVOID,vtx2:LPVOID,vtx_res:LPVOID
 mov esi,vtx1
 mov edx,vtx2
 mov edi,vtx_res
 fld qword ptr [esi]
 fsub qword ptr [edx]
 fstp qword ptr [edi]
 fld qword ptr [esi + 8]
 fsub qword ptr [edx + 8]
 fstp qword ptr [edi + 8]
 fld qword ptr [esi + 16]
 fsub qword ptr [edx + 16]
 fstp qword ptr [edi + 16]
 ret
vSubtract ENDP
 

vMultiplicate PROC vtx1:LPVOID,vtx2:LPVOID,vtx_res:LPVOID
 mov esi,vtx1
 mov edx,vtx2
 mov edi,vtx_res
 fld qword ptr [esi]
 fmul qword ptr [edx]
 fstp qword ptr [edi]
 fld qword ptr [esi + 8]
 fmul qword ptr [edx + 8]
 fstp qword ptr [edi + 8]
 fld qword ptr [esi + 16]
 fmul qword ptr [edx + 16]
 fstp qword ptr [edi + 16]
 ret
vMultiplicate ENDP




;VOID vRotate(double *source,double *dest,float angle,float xrot,float yrot,float zrot,dword numPoints)
vRotate PROC vtx_src:LPVOID,vtx_dest:LPVOID,angle:REAL4,xrot:REAL4,yrot:REAL4,zrot:REAL4,numPoints:DWORD
LOCAL cos1:REAL8,cos2:REAL8,cos3:REAL8
LOCAL sin1:REAL8,sin2:REAL8,sin3:REAL8
LOCAL xr:REAL8,yr:REAL8,zr:REAL8
 fld dword ptr [angle]
 fld dword ptr [xrot]
 fmul
 fsincos
 fstp qword ptr [cos1]
 fstp qword ptr [sin1]
 fld dword ptr [angle]
 fld dword ptr [yrot]
 fmul
 fsincos
 fstp qword ptr [cos2]
 fstp qword ptr [sin2]
 fld dword ptr [angle]
 fld dword ptr [zrot]
 fmul
 fsincos
 fstp qword ptr [cos3]
 fstp qword ptr [sin3]
 mov esi,vtx_src
 mov edi,vtx_dest
 mov ecx,numPoints
 R_@loop:
  fld qword ptr [esi]
  fstp qword ptr [edi]
  fld qword ptr [esi + 16]
  fld qword ptr [sin1]
  fmul
  fstp qword ptr [xr]
  fld qword ptr [esi + 8]
  fld qword ptr [cos1]
  fmul
  fsub qword ptr [xr]
  fstp qword ptr [yr]
  fld qword ptr [esi + 16]
  fmul qword ptr [cos1]
  fstp qword ptr [xr]
  fld qword ptr [esi + 8]
  fmul qword ptr [sin1]
  fadd qword ptr [xr]
  fstp qword ptr [edi + 16]
  fld qword ptr [yr]
  fstp qword ptr [edi + 8]
  fld qword ptr [edi + 16]
  fmul qword ptr [sin2]
  fstp qword ptr [yr]
  fld qword ptr [edi]
  fmul qword ptr [cos2]
  fsub qword ptr [yr]
  fstp qword ptr [xr]
  fld qword ptr [edi + 16]
  fmul qword ptr [cos2]
  fstp qword ptr [yr]
  fld qword ptr [edi]
  fmul qword ptr [sin2]
  fadd qword ptr [yr]
  fstp qword ptr [edi + 16]
  fld qword ptr [xr]
  fstp qword ptr [edi]
  fld qword ptr [edi + 8]
  fmul qword ptr [sin3]
  fstp qword ptr [zr]
  fld qword ptr [edi]
  fmul qword ptr [cos3]
  fsub qword ptr [zr]
  fstp qword ptr [xr]
  fld qword ptr [edi + 8]
  fmul qword ptr [cos3]
  fstp qword ptr [zr]
  fld qword ptr [edi]
  fmul qword ptr [sin3]
  fadd qword ptr [zr]
  fstp qword ptr [edi + 8]
  fld qword ptr [xr]
  fstp qword ptr [edi]
  add esi,24
  add edi,24
  dec ecx
 jnz R_@loop
 ret
vRotate ENDP



vTranslate PROC vtx_src:LPVOID,vtx_dest:LPVOID,xtrans:REAL4,ytrans:REAL4,ztrans:REAL4,numPoints:DWORD
 mov esi,vtx_src
 mov edi,vtx_dest
 mov ecx,numPoints
 T_@loop:
  fld qword ptr [esi]
  fadd dword ptr [xtrans]
  fstp qword ptr [edi]
  fld qword ptr [esi + 8]
  fadd dword ptr [ytrans]
  fstp qword ptr [edi + 8]
  fld qword ptr [esi + 16]
  fadd dword ptr [ztrans]
  fstp qword ptr [edi + 16]
  add esi,24
  add edi,24
  dec ecx
 jnz T_@loop
 ret
vTranslate ENDP



;FLOAT vScalar(double *vertex)
; returns value in st(0)
vScalar PROC vtx_src:LPVOID
LOCAL freg:REAL8
 mov esi,vtx_src
 fld qword ptr [esi]
 fmul qword ptr [esi]
 fstp qword ptr [freg]
 fld qword ptr [esi + 8]
 fmul qword ptr [esi + 8]
 fadd qword ptr [freg]
 fstp qword ptr [freg]
 fld qword ptr [esi + 16]
 fmul qword ptr [esi + 16]
 fadd qword ptr [freg]
 fsqrt
 ret
vScalar ENDP
  




;VOID GetScreenXY(double *vertexes_3D,DWORD *vertexes_2D,DWORD numPoints)
;parm [esi][edi][ecx]
GetScreenXY PROC vtx_3D:LPVOID,vtx_2D:LPVOID,numPoints:DWORD
 mov esi,vtx_3D
 mov edi,vtx_2D
 mov ecx,numPoints
 mov ebx,0
 mov edx,0
 GSXY_@loop:
  fldz					;\
  fsub qword ptr [esi + ebx + 16]	; \
  fld qword ptr [Camera + 16]		;  \
  fcompp				;   cmp (-vertex3D[i].Z),Camera.Z
  fstsw ax				;  /
  wait  				; /
  sahf					;/
  je GSXY_@negZ_eq_camZ
   fld qword ptr [esi + ebx + 16]	;\
   fadd qword ptr [Camera + 16]		; fscratch = vertex3D[i].Z + Camera.Z
   fstp qword ptr [fscratch8]		;/
   fld qword ptr [esi + ebx]		;\
   fmul qword ptr [Factor]		; \
   fdiv qword ptr [fscratch8]		;  vertex2D[i].X = ((vertex3D[i].X * Factor) / fscratch) + Camera.X
   fadd qword ptr [Camera]		; /
   fistp dword ptr [edi + edx]		;/
   fld qword ptr [esi + ebx + 8]
   fmul qword ptr [Factor]
   fdiv qword ptr [fscratch8]
   fadd qword ptr [Camera + 8]
   fistp dword ptr [edi + edx + 4]
  jmp GSXY_@endif
  GSXY_@negZ_eq_camZ:
   fld qword ptr [Camera]
   fistp dword ptr [edi + edx]
   fld qword ptr [Camera + 8]
   fistp dword ptr [edi + edx + 4]
  GSXY_@endif:
  add ebx,24
  add edx,8
  dec ecx
 jnz GSXY_@loop
 ret
GetScreenXY ENDP



.data

deg2rad		dq 0.0174533

Camera		dq 160.0,100.0,-300.0
Factor		dq 256.0

.data?
fscratch8	dq ?
fscratch4	dd ?

sine_table	dq 360 DUP(?)
cosine_table	dq 360 DUP(?)


; /Mic  | stabmaster_@hotmail.com
