; Waving Flag Effect for MASM
; By Mic, 2000
;
; How to compile:
;  ml /c /coff /Cp asmflag.asm
;  rc asmflag.rc
;  link /SUBSYSTEM:WINDOWS asmflag.obj asmflag.res





.686p
.mmx


.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE  ; case sensitivity enabled


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include beeampee2.inc
include tinyddraw.inc
include 3dmath.inc
include render.inc
include flags.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib beeampee2.lib
includelib tinyddraw.lib




myfloat typedef REAL8
myfloatptr equ <qword ptr>
MYFLOAT_SIZE equ 8
BYTES_PER_FLAG_ROW equ 528




.DATA
MyClassName db 'ClassName',0
WinTitleString db 'AsmFlag',0
szError db 'Error',0
szMMXError db 'This Program requires a Processor with MMX-instructions to run.',0
szempty db 65 dup (0)
snapname db 'flag.bmp',0

ALIGN DWORD

screenw dd 320
screenh dd 240
xpos dd 0
ypos dd 0
bpp dd 8

baseColors db 7,39,71,103,135,165,199,230

xan myfloat 35.0
yan myfloat 290.0
zan myfloat 1.0
d_xan myfloat 0.075
d_yan myfloat 0.08
d_xan2 myfloat 0.6
d_yan2 myfloat 0.628
d_zan2 myfloat 0.0
xamp myfloat 11.0
yamp myfloat 7.0
zamp myfloat 9.5
xmul myfloat 11.0
ymul myfloat 10.3

cameraTransX dd 95.0
cameraTransY dd 70.0
cameraTransZ dd 0.0

ohpointsixtyfive myfloat 0.45
onepointfive myfloat 1.5
two myfloat 2.0
sixpointeight myfloat 6.8
twelve myfloat 12.0
seventwenty myfloat 720.0
seventwentyone myfloat 721.0

flatShading dd 0
vscreen LPVOID NULL
lpMap LPVOID NULL

.DATA?
ALIGN DWORD

hdc HDC ?   ; GDI device context
pal db 1024 dup (?)
flag dq 792 dup (?)
flagxy dd 528 dup (?)
colors db 264 dup (?)
xan2 myfloat ?
yan2 myfloat ?
zan2 myfloat ?
xan3 myfloat ?
x_add myfloat ?
y_add myfloat ?
st_1 dq ?
st_2 dq ?

srcimg dd 6 dup (?)
       db 768 dup (?)
trgtimg dd 6 dup (?)
        db 768 dup (?)
	
hWindow HWND ?
hInstance HANDLE ?



.CODE


;INT CheckForMMX()
; Returns:
;  eax == 1 => Supports MMX
;  eax == 0 => Doesn't support MMX
CheckForMMX PROC
 pushfd
 pop eax
 mov edx,eax
 xor eax,0200000h
 push eax
 popfd
 pushfd
 pop eax
 xor eax,edx
 test eax,0200000h
 setz al
 movzx eax,al
 .if eax == 0
   mov eax,1
   cpuid
   bt edx,23
   setc al
   inc al
   movzx eax,al
   .if eax == 2
     mov eax,1
     ret
   .endif
 .endif
 xor eax,eax
 ret
CheckForMMX ENDP
 


Init PROC
LOCAL scratch:DWORD
  ; Initialize DirectDraw, the rendering lib and allocate a virtual screen.
  invoke DDInit,hWindow
  invoke DDSetGraphicsMode,320,240,8
  invoke DDCreatePrimarySurface
  invoke SetRenderMode,320,240,8
  invoke LocalAlloc,LPTR,76800		; 320*240
  mov vscreen,eax

  ; Calculate the palette.
  mov ecx,0
  mov edi,offset pal
  xor ebx,ebx
  pal_loop:
   mov eax,ecx
   mov ah,al
   shl al,3
   shl ah,2
   mov [edi],bl
   mov [edi+1],bl
   mov [edi+2],al
   mov [edi+128],al
   mov [edi+129],bl
   mov [edi+130],bl
   mov [edi+256],al
   mov [edi+257],al
   mov [edi+258],al
   mov scratch,ecx
   fild dword ptr [scratch]
   fdiv myfloatptr [ohpointsixtyfive]
   fistp dword ptr [scratch]
   mov edx,scratch
   mov [edi+384],dl
   mov [edi+385],dl
   mov [edi+386],dl
   mov scratch,ecx
   fild dword ptr [scratch]
   fmul myfloatptr [sixpointeight]
   fistp dword ptr [scratch]
   mov edx,scratch
   mov [edi+512],bl
   mov [edi+513],dl
   mov [edi+514],bl
   mov [edi+640],al
   mov [edi+641],bl
   mov [edi+642],al
   mov [edi+768],al
   mov [edi+769],ah
   mov [edi+770],bl
   mov [edi+896],al
   mov [edi+897],al
   mov [edi+898],bl
   add edi,4
   inc ecx
   cmp ecx,32
  jne pal_loop
  invoke DDSetPalette,ADDR pal    

  ; srcimg = {void *bitmapData,
  ;           int width,
  ;           int height,
  ;           HGLOBAL handle,
  ;           int bitsPerPixel,
  ;           int errorCode,
  ;           char palette[768]}
  ; The "handle" and "errorCode" members are of no importance when saving
  ; a bitmap (you might as well set them to zero). 
  mov edi,offset srcimg
  mov eax,vscreen
  add eax,14430
  mov ebx,320
  mov ecx,240
  mov edx,0
  mov [edi],eax
  mov [edi+4],ebx
  mov [edi+8],ecx
  mov [edi+12],edx
  mov eax,8
  mov ebx,0
  mov [edi+16],eax
  mov [edi+20],ebx
  add edi,24
  mov esi,offset pal
  mov ebx,256
  copy_pal_1:
   mov ecx,3
   rep movsb
   inc esi
   dec ebx
  jnz copy_pal_1

  ; trgtimg = same as srcimg except that the width and height are changed
  ; to cut away some large black portions of the screen.
  ; Also note that the value of trgtimg[0] (the pointer to the image data) is
  ; irrelevant since SaveBMP uses srcimg[0].
  mov edi,offset trgtimg
  mov eax,0
  mov ebx,260
  mov ecx,150
  mov edx,0
  mov [edi],eax
  mov [edi+4],ebx
  mov [edi+8],ecx
  mov [edi+12],edx
  mov eax,8
  mov ebx,0
  mov [edi+16],eax
  mov [edi+20],ebx
  add edi,24
  mov esi,offset pal
  mov ebx,256
  copy_pal_2:
   mov ecx,3
   rep movsb
   inc esi
   dec ebx
  jnz copy_pal_2
 
  ; Move the camera to get the flag centered on the screen.
  invoke vTranslate,ADDR Camera,
		    ADDR Camera,
		    cameraTransX,
		    cameraTransY,
		    cameraTransZ,
		    1
  mov eax,offset sweden
  mov lpMap,eax
  ret
Init ENDP


ShutDown PROC
 invoke DDClose
 invoke LocalFree,vscreen
 ret
ShutDown ENDP


Snapshot PROC
 invoke SaveBMP,ADDR snapname,ADDR srcimg,ADDR trgtimg
 ret
Snapshot ENDP



Display PROC
LOCAL i:DWORD,j:DWORD
LOCAL scratch:DWORD
LOCAL fscratch:myfloat
LOCAL point1:LPVOID,point2:LPVOID,point3:LPVOID,point4:LPVOID
LOCAL byte1:UCHAR,byte2:UCHAR,byte3:UCHAR

 ; Clear the virtual screen.
 mov edi,vscreen
 mov ecx,19200
 xor eax,eax
 rep stosd

 ; Place some points along three "occilating" sine-curves.
 fld myfloatptr [xan]
 fstp myfloatptr [xan2]
 fld myfloatptr [yan]
 fstp myfloatptr [yan2]
 fld myfloatptr [xan2]
 fstp myfloatptr [xan3] 
 mov i,0
 D_@loop1:
  fld myfloatptr [yan2]
  fdiv myfloatptr [two]
  fsin
  fmul myfloatptr [yamp]
  fstp myfloatptr [y_add]
  fld myfloatptr [xan3]
  fstp myfloatptr [xan2] 
  mov j,0
  D_@loop2:
   fld myfloatptr [xan2]
   fmul myfloatptr [onepointfive]
   fadd myfloatptr [yan2]
   fstp myfloatptr [zan2]
   fld myfloatptr [xan2]
   fdiv myfloatptr [two]
   fsin
   fmul myfloatptr [xamp]
   fstp myfloatptr [x_add]
   mov eax,j
   mov ecx,528
   mul ecx
   mov edi,offset flag
   add edi,eax
   mov eax,i
   shl eax,3
   lea eax,[eax*2 + eax]
   add edi,eax
   fild dword ptr [i]
   fmul myfloatptr [xmul]
   fadd myfloatptr [x_add]
   fstp qword ptr [edi]
   add edi,MYFLOAT_SIZE   
   fild dword ptr [j]
   fmul myfloatptr [ymul]
   fadd myfloatptr [y_add]
   fstp qword ptr [edi]
   add edi,MYFLOAT_SIZE   
   fld myfloatptr [zan2]
   fdiv myfloatptr [two]
   fsin
   fmul myfloatptr [zamp]
   fstp qword ptr [edi]
   fld myfloatptr [xan2]
   fadd myfloatptr [d_xan2]
   fstp myfloatptr [xan2]
   add j,1
   cmp j,12
  jne D_@loop2
  fld myfloatptr [yan2]
  fadd myfloatptr [d_yan2]
  fstp myfloatptr [yan2]
  add i,1
  cmp i,22
 jne D_@loop1
 invoke GetScreenXY,ADDR flag,ADDR flagxy,264

 ; Calculate the color of each point based on its z-position.
 ; color[i][j] = (int)((flag[i][j].z + zAmplitude) * (12.0 / zAmplitude)) 
 mov esi,offset flag
 add esi,16
 mov edi,offset colors
 mov i,0
 D_@loop3:
  mov j,0
  D_@loop4:
   fld qword ptr [esi]
   fadd myfloatptr [zamp]
   fstp qword ptr [st_1]
   fld myfloatptr [twelve]
   fdiv myfloatptr [zamp]
   fmul qword ptr [st_1]
   fistp dword ptr [scratch]
   mov eax,i
   mov ecx,22
   mul ecx
   mov edx,eax
   mov eax,scratch
   add edx,j
   mov [edi + edx],al
   add esi,24
   add j,1
   cmp j,22
  jne D_@loop4
  add i,1
  cmp i,12
 jne D_@loop3


 ; Now draw some polygons between the points. Each quadangle is split
 ; into two triangles to improve the shading quality somewhat.
 mov i,0
 D_@loop5:
  mov j,0
  D_@loop6:
   mov eax,i
   mov ecx,22
   mul ecx
   mov ecx,eax
   mov esi,offset flagxy
   mov point1,esi
   mov point2,esi
   mov point3,esi
   mov point4,esi
   mov eax,ecx
   shl eax,3
   mov ebx,j
   shl ebx,3
   add eax,ebx
   add point1,eax
   add eax,8
   add point4,eax
   add eax,176
   add point2,eax
   sub eax,8
   add point3,eax

   mov eax,220
   sub eax,ecx
   add eax,20
   sub eax,j
   add eax,lpMap
   xor ebx,ebx
   mov bl,[eax]
   dec bl 
   add ebx,offset baseColors
   xor eax,eax
   mov al,[ebx]

   xor ebx,ebx
   xor edx,edx
   mov esi,offset colors
   add ecx,j
   mov bl,[esi+ecx]
   inc ecx
   mov dh,[esi+ecx]
   add ecx,22
   mov dl,[esi+ecx]
   dec ecx
   mov cl,[esi+ecx]
   and ecx,0FFh

   .if (!flatShading) 
     add bl,al
     add cl,al
     add dl,al
     add dh,al
     mov byte1,bl
     mov byte2,dh
     mov byte3,dl
     invoke gouraud_triangle,point1,point2,point3,bl,dl,cl,vscreen
     invoke gouraud_triangle,point1,point4,point2,byte1,byte2,byte3,vscreen
   .else
     mov ah,bl
     add ah,dl
     shr ah,1
     add ah,cl
     shr ah,1
     add ah,al
     mov byte1,ah
     mov ah,bl
     add ah,dh
     shr ah,1
     add ah,dl
     shr ah,1
     add ah,al
     mov byte2,ah
     invoke triangle,point1,point2,point3,byte1,vscreen
     invoke triangle,point1,point4,point2,byte2,vscreen   
   .endif
   add j,1
   cmp j,21
  jne D_@loop6
  add i,1
  cmp i,11
 jne D_@loop5

 ; Wait for a vertical retrace to finish. Then lock the surface and
 ; copy the virtual screen to it.
 invoke DDWaitRetrace
 invoke DDLockSurface
 .IF eax != 0
   invoke PostQuitMessage,0
   ret
 .ENDIF
 invoke DDCopyToSurfaceMMX,0,0,vscreen,320,240
 invoke DDUnlockSurface

 fld myfloatptr [xan]
 fadd myfloatptr [d_xan]
 fstp myfloatptr [xan]
 fld myfloatptr [yan]
 fadd myfloatptr [d_yan]
 fstp myfloatptr [yan]
   
 ret
Display ENDP




MainWinProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL crect:RECT
LOCAL ps:PAINTSTRUCT
 mov eax,uMsg
  .if eax == WM_CREATE 
    mov eax,hWnd
    mov hWindow,eax
    xor eax,eax
    ret
  .elseif eax == WM_KEYDOWN
    .if wParam == VK_ESCAPE
      invoke PostMessage,hWnd,WM_DESTROY,wParam,lParam
    .elseif wParam == '1'
      push offset bahamas
      pop lpMap
    .elseif wParam == '2'
      push offset chile
      pop lpMap
    .elseif wParam == '3'
      push offset denmark
      pop lpMap
    .elseif wParam == '4'
      push offset finland
      pop lpMap
    .elseif wParam == '5'
      push offset france
      pop lpMap
    .elseif wParam == '6'
      push offset greece
      pop lpMap
    .elseif wParam == '7'
      push offset iceland
      pop lpMap
    .elseif wParam == '8'
      push offset ireland
      pop lpMap
    .elseif wParam == '9'
      push offset sweden
      pop lpMap
    .elseif wParam == '0'
      push offset trinidad
      pop lpMap
    .elseif wParam == 'F'
      mov flatShading,1
    .elseif wParam == 'G'
      mov flatShading,0
    .elseif wParam == 'S'
      call Snapshot
    .endif
    xor eax,eax
    ret
  .elseif eax == WM_CLOSE
    invoke PostQuitMessage,0
    xor eax,eax
    ret
  .elseif eax == WM_DESTROY
    invoke PostQuitMessage,0
    xor eax,eax
    ret
 .endif
 invoke DefWindowProc,hWnd,uMsg,wParam,lParam
 ret
MainWinProc ENDP




WinMain PROC hInst:DWORD,prevInstance:DWORD,cmdlinePtr:DWORD,cmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
 lea edi,wc
 sub eax,eax
 mov ecx,(sizeof WNDCLASSEX)/4
 rep stosd
 mov eax,hInst
 mov hInstance,eax
 mov wc.hInstance,eax
 mov wc.cbSize, sizeof WNDCLASSEX
 mov wc.style,CS_OWNDC or CS_HREDRAW or CS_VREDRAW
 mov wc.lpszClassName,offset MyClassName
 mov wc.lpfnWndProc,offset MainWinProc
 invoke LoadCursor,NULL,IDC_ARROW
 mov wc.hCursor,eax
 invoke GetStockObject,BLACK_BRUSH
 mov wc.hbrBackground,eax

 invoke RegisterClassEx,ADDR wc

 invoke CreateWindowEx,NULL,
                       ADDR MyClassName,
                       ADDR WinTitleString,
                       WS_POPUP,
                       0,0,
                       200,200,
                       NULL,
                       NULL,
                       hInst,
                       NULL
 mov hWindow,eax
 invoke SetCursor,NULL
 invoke ShowWindow,hWindow,SW_SHOW
 invoke SetFocus,hWindow
 call Init

 ; Enter message-loop
 eternal_loop:
   test_PM:
     invoke PeekMessage,ADDR msg,hWindow,0,0,PM_NOREMOVE
     cmp eax,0
     je endw_PM_nonzero
     invoke GetMessage,ADDR msg,hWindow,0,0
     .IF eax != 0
       invoke TranslateMessage,ADDR msg
       invoke DispatchMessage,ADDR msg
     .ELSE
       jmp get_out
     .ENDIF
   jmp test_PM  
   endw_PM_nonzero:
   call Display
 jmp eternal_loop
 get_out:
 call ShutDown
 invoke DestroyWindow,hWindow
 mov eax,msg.wParam
 ret
WinMain ENDP



Start:
;!!-> Execution starts here <-!!
 call CheckForMMX
 .if eax == 0 
   invoke MessageBox,NULL,ADDR szMMXError,ADDR szError,MB_ICONERROR
   invoke ExitProcess,0
 .endif
 invoke GetModuleHandle,NULL ; Get hInstance
 invoke WinMain,eax,NULL,NULL,NULL
 invoke ExitProcess,eax

END Start


; /Mic  |  stabmaster_@hotmail.com