; Polygon rendering lib
; Pentium Pro/Pentium II edition
; 
; By Mic, 2000
;
; Currently only capable of drawing flat (single-colored) and gouraud-shaded
; triangles in 8-bit modes (at resolutions up to 1024*768)



.data

point2Ddw STRUCT
 x	DWORD ?
 y	DWORD ?
point2Ddw ENDS

point2Df STRUCT
 x	REAL4 ?
 y	REAL4 ?
point2Df ENDS

point2Dd STRUCT
 x	REAL8 ?
 y	REAL8 ?
point2Dd ENDS

point3Ddw STRUCT
 x	DWORD ?
 y	DWORD ?
 z	DWORD ?
point3Ddw ENDS

point3Df STRUCT
 x	REAL4 ?
 y	REAL4 ?
 z	REAL4 ?
point3Df ENDS

point3Dd STRUCT
 x	REAL8 ?
 y	REAL8 ?
 z	REAL8 ?
point3Dd ENDS


tagVertexData STRUCT
 lpVertex	LPVOID	?
 deltaX		DWORD	?
 deltaY		DWORD	?
 deltaC		DWORD	?
 deltaU		DWORD	?
 deltaV		DWORD	?
 dxdy		DWORD	?
 dcdy		DWORD	?
 dudy		DWORD	?
 dvdy		DWORD	?
tagVertexData ENDS

tagVideo STRUCT
 address	LPVOID ?	
 screenW	DWORD ?
 screenH	DWORD ?
 maxX		DWORD ?
 maxY		DWORD ?
 bitsPerPixel	DWORD ?
tagVideo ENDS

tagEdgeBuffers STRUCT
 xmin dd 768 dup (?)
 xmax dd 768 dup (?)
 cmin dd 768 dup (?)
 cmax dd 768 dup (?)
 umin dd 768 dup (?)
 umax dd 768 dup (?)
 vmin dd 768 dup (?)
 vmax dd 768 dup (?)
tagEdgeBuffers ENDS

tagScan STRUCT
 x1 DWORD ?
 y1 DWORD ?
 c1 DWORD ?
 u1 DWORD ?
 v1 DWORD ?
 x2 DWORD ?
 y2 DWORD ?
 c2 DWORD ?
 u2 DWORD ?
 v2 DWORD ?
tagScan ENDS


tagRendererData STRUCT
 vertex1	tagVertexData <?>
 vertex2	tagVertexData <?>
 vertex3	tagVertexData <?>
 vertex4	tagVertexData <?>
 scan		tagScan <?>
 dxdy_temp1	DWORD	?	
 dxdy_temp2	DWORD	?	

 startX		DWORD	?
 endX		DWORD	?
 startY		DWORD	?
 endY		DWORD	?

 color		DWORD	?
 texture	LPVOID	?
 gScanProc	LPVOID	?
 tScanProc	LPVOID	?
 lineProc	LPVOID	?
 gLineProc	LPVOID	?
 tLineProc	LPVOID	?
 video		tagVideo <?>
 dummy		DWORD ?
tagRendererData ENDS


rendererData tagRendererData <>

.data?

edgeBuffers tagEdgeBuffers <>



.code

drawsection8 PROC
 mov eax,rendererData.startY
 cmp eax,rendererData.video.maxY
 jng ds8_@y1_ok 
  ret
 ds8_@y1_ok:
 mov ecx,rendererData.endY
 cmp ecx,0
 jge ds8_@y2_ok
  ret 
 ds8_@y2_ok: 
 xor edx,edx
 cmp eax,edx
 ;jge ds8_@y1_ok_2
 ; mov eax,0 
 ;ds8_@y1_ok_2:
 cmovl eax,edx
 cmp ecx,rendererData.video.maxY 
 ;jng ds8_@y2_ok_2 
 ; mov ecx,rendererData.video.maxY
 ;ds8_@y2_ok_2:
 cmovg ecx,rendererData.video.maxY 
 sub ecx,eax
 inc ecx
 cmp ecx,0 
 jg ds8_@height_ok 
  ret 
 ds8_@height_ok:
 imul rendererData.video.screenW 
 add edi,eax 					;-- edi = dest+(y*screenW)
 mov edx,rendererData.startX 
 mov ebx,rendererData.endX 
 ds8_@yloop: 
  push edi 
  push ecx 
  ;--"mov edx,ecx 
  mov rendererData.startX,edx 
  ;--"mov [x2],ebx
  ;mov edx,ebx 
  push ebx
  sar edx,9
  sar ebx,9 
  cmp edx,ebx 					
  jng ds8_@x1_ng_x2 				
   ;--"xchg edx,ebx 				
   mov eax,edx
   mov edx,ebx
   mov ebx,eax 		
  ds8_@x1_ng_x2:				
  cmp edx,rendererData.video.maxX
  jg ds8_@yloop_next
  cmp ebx,0 
  jl ds8_@yloop_next
  cmp edx,0 
  ;jge ds8_@x1_nl_zero 
  ; mov edx,0 
  ;ds8_@x1_nl_zero: 
  cmovl edx,rendererData.dummy
  cmp ebx,rendererData.video.maxX
  ;jng ds8_@x2_ng_maxW 
  ; mov ebx,rendererData.video.maxX 
  ;ds8_@x2_ng_maxW: 
  cmovg ebx,rendererData.video.maxX 
  mov ecx,ebx 
  sub ecx,edx 
  inc ecx
  add edi,edx					;-- edi += x1
  mov edx,ecx
  and edx,3 
  shr ecx,2
  mov eax,rendererData.color
  rep stosd
  ;cmp edx,0
  ;je ds8_@yloop_next
  mov ecx,edx 
  rep stosb 
  ds8_@yloop_next:
  mov edx,rendererData.startX
  ;--"mov ebx,[x2]
  ;mov ebx,edx 
  pop ebx
  pop ecx 
  pop edi
  add edi,rendererData.video.screenW
  add edx,rendererData.dxdy_temp1
  add ebx,rendererData.dxdy_temp2
  dec ecx
 jnz ds8_@yloop
 mov rendererData.endX,ebx
 ret
drawsection8 ENDP



flat_tri PROC
 cld
 mov esi,rendererData.vertex1.lpVertex
 mov edi,rendererData.vertex2.lpVertex 
 mov ebx,rendererData.vertex3.lpVertex
 mov eax,[esi + 4]		;-- eax = y1
 cmp eax,[edi + 4] 		;-- cmp y1,y2
 jng tri_@y1_ng_y2
   ;--  xchg esi,edi
   mov eax,esi
   mov esi,edi
   mov edi,eax
 tri_@y1_ng_y2:
 mov eax,[esi + 4]		;-- eax = y1
 cmp eax,[ebx + 4] 		;-- cmp y1,y3
 jng tri_@y2_ng_y3
   ;--  xchg esi,ebx
   mov eax,esi
   mov esi,ebx
   mov ebx,eax
 tri_@y2_ng_y3: 
 mov eax,[edi + 4]		;-- eax = y2
 cmp eax,[ebx + 4]		;-- cmp y2,y3
 jng tri_@y1_ng_y3 
   ;--  xchg edi,ebx 
   mov eax,edi
   mov edi,ebx
   mov ebx,eax
 tri_@y1_ng_y3:
 mov rendererData.vertex1.lpVertex,esi
 mov rendererData.vertex2.lpVertex,edi 
 mov rendererData.vertex3.lpVertex,ebx 
 mov eax,[edi]
 sub eax,[esi]
 inc eax
 mov rendererData.vertex1.deltaX,eax 
 mov eax,[ebx] 
 sub eax,[edi] 
 inc eax
 mov rendererData.vertex2.deltaX,eax
 mov eax,[ebx] 		
 sub eax,[esi] 		
 inc eax
 mov rendererData.vertex3.deltaX,eax
 mov eax,[edi + 4]
 sub eax,[esi + 4] 
 inc eax
 mov rendererData.vertex1.deltaY,eax
 mov eax,[ebx + 4]
 sub eax,[edi + 4] 
 inc eax
 mov rendererData.vertex2.deltaY,eax
 mov eax,[ebx + 4] 		
 sub eax,[esi + 4]		
 inc eax
 mov rendererData.vertex3.deltaY,eax
 xor ecx,ecx 
 mov rendererData.vertex1.dxdy,0
 mov rendererData.vertex2.dxdy,0
 mov rendererData.vertex3.dxdy,0
 cmp rendererData.vertex3.deltaY,0
 jne tri_@keep_going
   ret 			;-- return if (y3-y1) = 0
 tri_@keep_going: 
   inc ecx 
   mov eax,rendererData.vertex3.deltaX
   sal eax,9 
   mov ebx,rendererData.vertex3.deltaY
   cdq
   idiv ebx 
   mov rendererData.vertex3.dxdy,eax
 cmp rendererData.vertex2.deltaY,0 
 je tri_@delta_y_2_zero
   inc ecx
   mov eax,rendererData.vertex2.deltaX 
   sal eax,9 
   mov ebx,rendererData.vertex2.deltaY 
   cdq 
   idiv ebx
   mov rendererData.vertex2.dxdy,eax 
 tri_@delta_y_2_zero:
 cmp rendererData.vertex1.deltaY,0 
 je tri_@delta_y_1_zero 
   inc ecx
   mov eax,rendererData.vertex1.deltaX
   sal eax,9
   mov ebx,rendererData.vertex1.deltaY
   cdq 
   idiv ebx 
   mov rendererData.vertex1.dxdy,eax 
 tri_@delta_y_1_zero:
 cmp ecx,0 
 jne tri_@enough_height
   ret 				;-- return if the triangle has zero height
 tri_@enough_height:
 mov rendererData.dummy,0
 mov eax,rendererData.vertex1.lpVertex 
 mov ebx,rendererData.vertex2.lpVertex 
 mov edx,[eax + 4] 
 mov eax,[ebx + 4] 
 mov rendererData.startY,edx 
 mov rendererData.endY,eax
 mov ebx,rendererData.vertex1.lpVertex 
 mov eax,[ebx] 
 sal eax,9 
 mov rendererData.startX,eax 
 mov rendererData.endX,eax 
 mov eax,rendererData.vertex1.dxdy
 mov ebx,rendererData.vertex3.dxdy 
 mov rendererData.dxdy_temp1,eax 
 mov rendererData.dxdy_temp2,ebx 
 mov edi,rendererData.video.address 
 mov ebx,rendererData.lineProc 
 call ebx 			;-- draw upper section
 mov ebx,rendererData.vertex2.lpVertex 
 mov ebx,[ebx] 
 sal ebx,9 
 mov rendererData.startX,ebx 
 mov eax,rendererData.vertex2.lpVertex 
 mov ebx,rendererData.vertex3.lpVertex 
 mov edx,[eax+4] 
 mov eax,[ebx+4] 
 mov rendererData.startY,edx 
 mov rendererData.endY,eax 
 mov eax,rendererData.vertex2.dxdy 
 mov ebx,rendererData.vertex3.dxdy 
 mov rendererData.dxdy_temp1,eax 
 mov rendererData.dxdy_temp2,ebx 
 mov edi,rendererData.video.address 
 mov ebx,rendererData.lineProc 
 call ebx 			;-- draw lower section
 ret
flat_tri ENDP


triangle PROC vtx1:LPVOID,vtx2:LPVOID,vtx3:LPVOID,col:UCHAR,dest:LPVOID
 mov eax,dest
 mov rendererData.video.address,eax
 and eax,255
 mov al,col
 mov ah,al
 mov ebx,eax
 shl ebx,16
 or eax,ebx
 mov rendererData.color,eax
 mov eax,vtx1
 mov rendererData.vertex1.lpVertex,eax
 mov eax,vtx2
 mov rendererData.vertex2.lpVertex,eax
 mov eax,vtx3
 mov rendererData.vertex3.lpVertex,eax
 call flat_tri
 ret
triangle ENDP



gouraud8_scan PROC
LOCAL qwerty:DWORD
 mov eax,rendererData.scan.y2
 mov ebx,rendererData.scan.y1
 cmp eax,ebx 
 jne sgps_@do_stuff
  ret
 sgps_@do_stuff:
 cmp eax,ebx 
 jnl sgps_@y2_nl_y1
  mov rendererData.scan.y2,ebx 
  mov rendererData.scan.y1,eax
  mov eax,rendererData.scan.x2
  mov ebx,rendererData.scan.x1
  mov rendererData.scan.x2,ebx 
  mov rendererData.scan.x1,eax
  mov eax,rendererData.scan.c2
  mov ebx,rendererData.scan.c1 
  mov rendererData.scan.c2,ebx
  mov rendererData.scan.c1,eax 
 sgps_@y2_nl_y1:
 mov eax,rendererData.scan.c2 
 sub eax,rendererData.scan.c1
 sal eax,8 
 cdq 
 mov ebx,rendererData.scan.y2 
 sub ebx,rendererData.scan.y1 
 idiv ebx 
 mov edi,eax 
 mov eax,rendererData.scan.x2
 sub eax,rendererData.scan.x1
 sal eax,9 
 cdq 
 idiv ebx 
 mov esi,eax 
 mov eax,rendererData.scan.y2 
 inc eax
 mov qwerty,eax
 mov ebx,rendererData.scan.c1
 sal ebx,8 
 mov edx,rendererData.scan.x1 
 sal edx,9 
 mov ecx,rendererData.scan.y1 
 sgps_@loop:
  cmp ecx,0
  jl sgps_@skip
  cmp ecx,rendererData.video.screenH
  jge sgps_@skip
  push edx
  push ecx 
  sar edx,9 
  lea ecx,[ecx*4]
  cmp edx,[edgeBuffers.xmin + ecx] 
  jnl sgps_@x_nl_xmin
  mov [edgeBuffers.xmin + ecx],edx 
  mov [edgeBuffers.cmin + ecx],ebx 
  sgps_@x_nl_xmin:
  cmp edx,[edgeBuffers.xmax + ecx] 
  jng sgps_@x_ng_xmax 
  mov [edgeBuffers.xmax + ecx],edx
  mov [edgeBuffers.cmax + ecx],ebx 
  sgps_@x_ng_xmax: 
  pop ecx
  pop edx 
  sgps_@skip: 
  add edx,esi
  add ebx,edi 
  inc ecx 
  cmp ecx,qwerty
 jne sgps_@loop
 ret
gouraud8_scan ENDP




gouraud8_lines PROC 
LOCAL qwerty:DWORD
 mov eax,rendererData.startY 
 lea ebx,[eax*4] 
 mov ecx,rendererData.video.screenW
 mul ecx
 mov qwerty,eax 
 mov ecx,rendererData.endY      ; use endY as numberOfLines 
 ghl_@yloop:
  push ecx
  mov edi,rendererData.video.address
  add edi,qwerty 
  mov eax,[edgeBuffers.xmin + ebx] 
  cmp eax,rendererData.video.maxX
  jg ghl_@skip
  cmp eax,0 
  ;jnl ghl_@xmin_nl_0
  ; mov eax,0
  ;ghl_@xmin_nl_0:
  cmovl eax,rendererData.dummy
  mov ecx,[edgeBuffers.xmax + ebx] 
  cmp ecx,0 
  jl ghl_@skip
  cmp ecx,rendererData.video.maxX
  ;jng ghl_@xmax_ng_maxW 
  ; mov ecx,rendererData.video.maxX 
  ;ghl_@xmax_ng_maxW:
  cmovg ecx,rendererData.video.maxX
  add edi,eax 
  sub ecx,eax
  inc ecx 
  mov eax,[edgeBuffers.cmax + ebx]
  sub eax,[edgeBuffers.cmin + ebx]
  cdq
  idiv ecx
  mov edx,eax 
  mov eax,[edgeBuffers.cmin + ebx] 
  lea edi,[edi + ecx]
  dec edi
  xor ecx,-1 
  inc ecx 
  ghl_@xloop:
   mov [edi + ecx],ah		;-- (uchar *)(edi) = (ax >> 8)
   add eax,edx 
   inc ecx 
  jnz ghl_@xloop 
  ghl_@skip:
  pop ecx
  add ebx,4 
  mov eax,rendererData.video.screenW 
  add qwerty,eax
  dec ecx 
 jnz ghl_@yloop
 ret
gouraud8_lines ENDP



gouraud_triangle PROC vtx1:LPVOID,vtx2:LPVOID,vtx3:LPVOID,col1:UCHAR,col2:UCHAR,col3:UCHAR,dest:LPVOID
LOCAL asdfg:DWORD
 mov edi,offset edgeBuffers.xmin
 mov eax,8000
 mov ecx,rendererData.video.screenH
 rep stosd
 neg eax
 mov edi,offset edgeBuffers.xmax
 mov ecx,rendererData.video.screenH
 rep stosd
 mov rendererData.dummy,0
 mov esi,vtx1
 mov edi,vtx2
 mov eax,[esi]
 mov ebx,[esi + 4]
 and ecx,255
 mov cl,col1
 mov rendererData.scan.x1,eax
 mov rendererData.scan.y1,ebx
 mov rendererData.scan.c1,ecx
 mov eax,[edi]
 mov ebx,[edi + 4]
 mov cl,col2
 mov rendererData.scan.x2,eax
 mov rendererData.scan.y2,ebx
 mov rendererData.scan.c2,ecx
 mov eax,rendererData.gScanProc
 call eax
 mov esi,vtx2
 mov edi,vtx3
 mov eax,[esi]
 mov ebx,[esi + 4]
 and ecx,255
 mov cl,col2
 mov rendererData.scan.x1,eax
 mov rendererData.scan.y1,ebx
 mov rendererData.scan.c1,ecx
 mov eax,[edi]
 mov ebx,[edi + 4]
 mov cl,col3
 mov rendererData.scan.x2,eax
 mov rendererData.scan.y2,ebx
 mov rendererData.scan.c2,ecx
 mov eax,rendererData.gScanProc
 call eax
 mov esi,vtx3
 mov edi,vtx1
 mov eax,[esi]
 mov ebx,[esi + 4]
 and ecx,255
 mov cl,col3
 mov rendererData.scan.x1,eax
 mov rendererData.scan.y1,ebx
 mov rendererData.scan.c1,ecx
 mov eax,[edi]
 mov ebx,[edi + 4]
 mov cl,col1
 mov rendererData.scan.x2,eax
 mov rendererData.scan.y2,ebx
 mov rendererData.scan.c2,ecx
 mov eax,rendererData.gScanProc
 call eax
 mov esi,vtx1
 mov eax,[esi + 4]
 mov ebx,eax
 mov esi,vtx2
 mov ecx,[esi + 4]
 cmp ecx,eax
 jnl gtri_@maybe_y2_g_ymax
  mov eax,ecx
  jmp gtri_@check_y3
 gtri_@maybe_y2_g_ymax:
 cmp ecx,ebx
 ;jng gtri_@check_y3
 ; mov ebx,ecx
 cmovg ebx,ecx
 gtri_@check_y3:
 mov esi,vtx3
 mov ecx,[esi + 4]
 cmp ecx,eax
 jnl gtri_@maybe_y3_g_ymax
  mov eax,ecx
  jmp gtri_@check_done
 gtri_@maybe_y3_g_ymax:
 cmp ecx,ebx
 ;jng gtri_@check_done
 ; mov ebx,ecx
 cmovg ebx,ecx
 gtri_@check_done:
 ; current conditions:
 ;  eax = ymin
 ;  ebx = ymax
 cmp eax,rendererData.video.maxY
 jg gtri_@return
 cmp ebx,0
 jl gtri_@return
 cmp eax,0
 ;jge gtri_@ymin_ok
 ; xor eax,eax
 ;gtri_@ymin_ok:
 cmovl eax,rendererData.dummy
 cmp ebx,rendererData.video.maxY
 ;jng gtri_@ymax_ok
 ; mov ebx,rendererData.video.maxY
 ;gtri_@ymax_ok:
 cmovg ebx,rendererData.video.maxY
 mov rendererData.startY,eax
 sub ebx,eax
 inc ebx
 mov rendererData.endY,ebx
 mov eax,dest
 mov rendererData.video.address,eax
 mov eax,rendererData.gLineProc
 call eax
 gtri_@return:
 ret
gouraud_triangle ENDP






SetRenderMode PROC xdim:DWORD,ydim:DWORD,bpp:DWORD
 mov eax,xdim
 mov ebx,ydim
 mov ecx,bpp
 mov rendererData.video.screenW,eax
 mov rendererData.video.screenH,ebx
 mov rendererData.video.bitsPerPixel,ecx
 dec eax
 dec ebx
 mov rendererData.video.maxX,eax
 mov rendererData.video.maxY,ebx
 .IF bpp == 8
   mov eax,offset drawsection8
   mov rendererData.lineProc,eax
   mov eax,offset gouraud8_scan
   mov rendererData.gScanProc,eax
   mov eax,offset gouraud8_lines
   mov rendererData.gLineProc,eax
 .ENDIF
 ret
SetRenderMode ENDP


SetRenderPitch PROC pitch:DWORD
 mov eax,pitch
 mov rendererData.video.screenW,eax
 ret
SetRenderPitch ENDP




	 	